#include "arm9.h"

#ifdef PROGRAMMING_MODE

char *text_progmode[]={
 "ADDR: 00000000",
 "DATA: 00000000 ....",
 "EXEC: ARM7 ARM9",
 "CMD : EXIT"};

void menu_progmode() {
	u32 i,j,sel1,sel2;
	u32 k,addr1=0,data1=0;
	u16 *p;
	char *s;

	sel1=0; sel2=0;
	while(1) {
		swiWaitForVBlank();
		
		for(i=0;i<4;i++) {
			p=(u16*)(SCREEN_BASE_BLOCK_SUB(0)+i*64);
			s=text_progmode[i];
			k=0;
			while(*s) {
				k++;
				if(i<2) *p++=(*s++)|(sel1==i && sel2+7==k?0x1000:0);
				if(i==2) {
					j=(k>5 && k<11 && (sel2&1)==0) || (k>10 && (sel2&1)==1);
					*p++=(*s++)|(j && sel1==2?0x1000:0);
				}
				if(i==3) *p++=(*s++)|(k>5 && sel1==3?0x1000:0);
			}
		}
		k=keysDown();
		if(IPC_XKEYS & 0x80)	//lid closed
			arm9sleep();
		if((k&KEY_UP) && sel1>0)
			sel1--;
		if((k&KEY_DOWN) && sel1<3)
			sel1++;
		if(k&KEY_LEFT) sel2=(sel2+7)%8;
		if(k&KEY_RIGHT) sel2=(sel2+1)%8;
		if((k&KEY_A) && sel1==0) addr1+=1<<(4*(7-sel2));
		if((k&KEY_B) && sel1==0) addr1-=1<<(4*(7-sel2));
		if((k&KEY_SELECT) && sel1==0) addr1=0;
		if((k&KEY_SELECT) && sel1==1) {
			addr1+=4;
			sel2=0;
		}
		if(((k&KEY_A)||(k&KEY_B)) && sel1==1) {
			if(k&KEY_A) data1+=1<<(4*(7-sel2));
			if(k&KEY_B) data1-=1<<(4*(7-sel2));
			if(sel2==0 || sel2==1) Write_PMemory(addr1,(data1>>24)&0xFF);
			if(sel2==2 || sel2==3) Write_PMemory(addr1+1,(data1>>16)&0xFF);
			if(sel2==4 || sel2==5) Write_PMemory(addr1+2,(data1>>8)&0xFF);
			if(sel2==6 || sel2==7) Write_PMemory(addr1+3,(data1>>0)&0xFF);
		}
		if((k&KEY_SELECT) && sel1==2) {
			if(sel2&1) ((call0)addr1)();
			else {
				IPC_ARM9_P1=addr1;
				IPC_ARM9=IPC_CALL_ARM7;
			}
		}
		//if(k&KEY_L)
		//	lcdSwap();
		if(k&KEY_START || ((k&KEY_SELECT) && sel1==3))
			return;
		if(k) {
			for(i=0;i<8;i++) {
				j=(addr1>>((7-i)*4))&15;
				if(j>=10) text_progmode[0][6+i]=j-10+'A';
				else text_progmode[0][6+i]=j+'0';
			}
			data1=Read_PMemory(addr1)<<24;
			data1+=Read_PMemory(addr1+1)<<16;
			data1+=Read_PMemory(addr1+2)<<8;
			data1+=Read_PMemory(addr1+3)<<0;
			for(i=0;i<8;i++) {
				j=(data1>>((7-i)*4))&15;
				if(j>=10) text_progmode[1][6+i]=j-10+'A';
				else text_progmode[1][6+i]=j+'0';
			}
			text_progmode[1][15]=Read_PMemory(addr1);
			text_progmode[1][16]=Read_PMemory(addr1+1);
			text_progmode[1][17]=Read_PMemory(addr1+2);
			text_progmode[1][18]=Read_PMemory(addr1+3);
		}
	}
}
#endif

